function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Entity, Index, JoinColumn, Column, PrimaryColumn, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let UserGroup = class UserGroup {
    id;
    createdAt;
    name;
    username;
    userId;
    user;
    isPrivate;
    allowCalls;
    iconFileId;
    symbolFileId;
    constructor(data){
        if (data == null) return;
        for (const [k, v] of Object.entries(data)){
            this[k] = v;
        }
    }
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], UserGroup.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the UserGroup."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], UserGroup.prototype, "createdAt", void 0);
_ts_decorate([
    Column("varchar", {
        length: 256
    }),
    _ts_metadata("design:type", String)
], UserGroup.prototype, "name", void 0);
_ts_decorate([
    Index({
        unique: true
    }),
    Column("varchar", {
        length: 64,
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], UserGroup.prototype, "username", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The ID of owner."
    }),
    _ts_metadata("design:type", Object)
], UserGroup.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], UserGroup.prototype, "user", void 0);
_ts_decorate([
    Column("boolean", {
        default: false
    }),
    _ts_metadata("design:type", Boolean)
], UserGroup.prototype, "isPrivate", void 0);
_ts_decorate([
    Column("boolean", {
        default: true
    }),
    _ts_metadata("design:type", Boolean)
], UserGroup.prototype, "allowCalls", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], UserGroup.prototype, "iconFileId", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], UserGroup.prototype, "symbolFileId", void 0);
UserGroup = _ts_decorate([
    Entity(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
        typeof Partial === "undefined" ? Object : Partial
    ])
], UserGroup);
